/* Copyright  (c) 2002 Graz University of Technology. All rights reserved.
 *
 * Redistribution and use in  source and binary forms, with or without 
 * modification, are permitted  provided that the following conditions are met:
 *
 * 1. Redistributions of  source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in  binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *  
 * 3. The end-user documentation included with the redistribution, if any, must
 *    include the following acknowledgment:
 * 
 *    "This product includes software developed by IAIK of Graz University of
 *     Technology."
 * 
 *    Alternately, this acknowledgment may appear in the software itself, if 
 *    and wherever such third-party acknowledgments normally appear.
 *  
 * 4. The names "Graz University of Technology" and "IAIK of Graz University of
 *    Technology" must not be used to endorse or promote products derived from 
 *    this software without prior written permission.
 *  
 * 5. Products derived from this software may not be called 
 *    "IAIK PKCS Wrapper", nor may "IAIK" appear in their name, without prior 
 *    written permission of Graz University of Technology.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 *  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 *  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *  PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE LICENSOR BE
 *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 *  OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 *  OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 *  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 *  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY  OF SUCH DAMAGE.
 */

/*
 * pkcs11wrapper.c
 * 18.05.2001
 *
 * This module contains the native functions of the Java to PKCS#11 interface
 * which are platform dependent. This includes loading a dynamic link libary,
 * retrieving the function list and unloading the dynamic link library.
 *
 * @author Karl Scheibelhofer <Karl.Scheibelhofer@iaik.at>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include <dbgapi.h>
#include <jni.h>

#ifdef DEBUG
/* #include <string.h> */
#endif

#define assert(assertionStatement) ASSERT(assertionStatement)



/*
 * Class:     iaik_pkcs_pkcs11_wrapper_PKCS11Implementation
 * Method:    connect
 * Signature: (Ljava/lang/String;)V
 */
JNIEXPORT void JNICALL Java_iaik_pkcs_pkcs11_wrapper_PKCS11Implementation_connect
	(JNIEnv *env, jobject obj, jstring jPkcs11ModulePath)
{
  HINSTANCE hModule;
  CK_C_GetFunctionList C_GetFunctionList;
  CK_RV rv;
  ModuleData *moduleData;
  jobject globalPKCS11ImplementationReference;
  unsigned short *utfLibraryNameStr;
  LPVOID lpMsgBuf;
  unsigned short *exceptionMessage;
#ifdef DEBUG
  FILE *debugOutputFile;
  FILE *rawLibraryNameFile;
  size_t libraryNameLength;
#endif

  const jchar *libraryNameStr = (*env)->GetStringChars(env, jPkcs11ModulePath, NULL);
  jsize libraryNameStrLength = (*env)->GetStringLength(env, jPkcs11ModulePath);

  utfLibraryNameStr = jCharArrayToNativeString(libraryNameStr, libraryNameStrLength);
  (*env)->ReleaseStringChars(env, jPkcs11ModulePath, libraryNameStr);

#ifdef DEBUG
  wprintf(L"DEBUG: connect to PKCS#11 module: %ls ... ", utfLibraryNameStr);
  fflush(stdout);
  debugOutputFile = _wfopen(L"ppkcs11wrapper_debug.txt", L"wt");
  fwprintf(debugOutputFile, L"DEBUG: connect to PKCS#11 module: %ls ... ", utfLibraryNameStr);
  fflush(debugOutputFile);
  rawLibraryNameFile = _wfopen(L"ppkcs11wrapper_dll_name.dat", L"wb");
  libraryNameLength = wcslen(utfLibraryNameStr);
  fwrite((const void *) utfLibraryNameStr, sizeof(unsigned short), wcslen(utfLibraryNameStr), rawLibraryNameFile);
  fflush(rawLibraryNameFile);
  fclose(rawLibraryNameFile);
#endif


  /*
   * Load the PKCS #11 DLL
   */
  hModule = LoadLibrary(utfLibraryNameStr);
  if (hModule == NULL) {
    FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER |
        FORMAT_MESSAGE_FROM_SYSTEM |
        FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        GetLastError(),
        0, /* Default language */
        (LPTSTR) &lpMsgBuf,
        0,
        NULL
    );
    exceptionMessage = (short *) malloc(sizeof(short) * (wcslen((LPTSTR) lpMsgBuf) + wcslen(libraryNameStr) + 1));
    wcscpy(exceptionMessage, (LPTSTR) lpMsgBuf);
    wcscat(exceptionMessage, libraryNameStr);
#ifdef DEBUG
    fwprintf(debugOutputFile, L"Error loading library: %ls\n", exceptionMessage);
    fflush(debugOutputFile);
    fclose(debugOutputFile);
#endif
    throwIOExceptionUnicodeMessage(env, exceptionMessage);
    /* Free the buffer. */
    free(exceptionMessage);
    LocalFree(lpMsgBuf);
    return;
  }
#ifdef DEBUG
  fwprintf(debugOutputFile, L"loaded successfully\n");
  fflush(debugOutputFile);
#endif

  /*
   * Get function pointer to C_GetFunctionList
   */
#ifdef DEBUG
  fwprintf(debugOutputFile, L"DEBUG: getting procedure address C_GetFunctionList... ");
#endif
  C_GetFunctionList = (CK_C_GetFunctionList) GetProcAddress(hModule, L"C_GetFunctionList");
  if (C_GetFunctionList == NULL) {
    FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER |
        FORMAT_MESSAGE_FROM_SYSTEM |
        FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        GetLastError(),
        0, /* Default language */
        (LPTSTR) &lpMsgBuf,
        0,
        NULL
    );
#ifdef DEBUG
    fwprintf(debugOutputFile, L"Error getting procedure address of C_GetFunctionList\n");
    fwprintf(debugOutputFile, (LPTSTR) lpMsgBuf);
    fflush(debugOutputFile);
    fclose(debugOutputFile);
#endif
    throwIOExceptionUnicodeMessage(env, (LPTSTR) lpMsgBuf);
    /* Free the buffer. */
    LocalFree( lpMsgBuf );
    return;
  }
#ifdef DEBUG
  fwprintf(debugOutputFile, L"got procedure address successfully\n");
  fflush(debugOutputFile);
#endif

  /*
   * Get function pointers to all PKCS #11 functions
   */
#ifdef DEBUG
  fwprintf(debugOutputFile, L"allocating new module data\n");
  fflush(debugOutputFile);
#endif
  moduleData = (ModuleData *) malloc(sizeof(ModuleData));
  moduleData->hModule = hModule;
  moduleData->applicationMutexHandler = NULL;
#ifdef DEBUG
  fwprintf(debugOutputFile, L"getting function list\n");
  fflush(debugOutputFile);
#endif
  rv = (C_GetFunctionList)(&(moduleData->ckFunctionListPtr));
#ifdef DEBUG
  fwprintf(debugOutputFile, L"getting global reference\n");
  fflush(debugOutputFile);
#endif
  globalPKCS11ImplementationReference = (*env)->NewGlobalRef(env, obj);
  putModuleEntry(env, globalPKCS11ImplementationReference, moduleData);

  TRACE0("FINISHED\n");

  if(ckAssertReturnValueOK(env, rv) != CK_ASSERT_OK) { return; }

#ifdef DEBUG
  fwprintf(debugOutputFile, L"connect FINISHED\n");
  fflush(debugOutputFile);
  fclose(debugOutputFile);
#endif
}

/*
 * Class:     iaik_pkcs_pkcs11_wrapper_PKCS11Implementation
 * Method:    disconnect
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_iaik_pkcs_pkcs11_wrapper_PKCS11Implementation_disconnect
	(JNIEnv *env, jobject obj)
{
  ModuleData *moduleData;
  TRACE0("DEBUG: disconnecting module...");
  moduleData = removeModuleEntry(env, obj);

	if (moduleData != NULL) {
		FreeLibrary(moduleData->hModule);
	}

  free(moduleData);
  TRACE0("FINISHED\n");

}
